-- 日常数据

local Daily = class("Daily", require("shared.ModelBase"))

function Daily:ctor(properties)
	Daily.super.ctor(self, properties)
end

Daily.schema = {
	commentHero		= {"string", ""},		-- 单日评论食灵记录 type=1
	hangQC			= {"number", 0},		-- 挂机快速次数
	dinerQC			= {"number", 0},		-- 贩卖加速次数
}

function Daily:updateProperty(params)
	local type, default = table.unpack(self.schema[params.field])

	if params.delta then
		self:setProperty(params.field, self:getProperty(paramsfield) + params.delta)
		self.owner:notifyUpdateProperty(params.field, self:getProperty(params.field))
		return true
	end
	if params.value then
		self:setProperty(params.field, params.value)
		self.owner:notifyUpdateProperty(params.field, self:getProperty(params.field))
		return true
	end
	return false
end

function Daily:refreshDailyData(notify)
	for field, schema in pairs(self.schema) do
		if field ~= "key" then
			local typ, def = table.unpack(schema)
			self:setProperty(field, def)
		end
	end
	if notify then
		self.owner:notifyUpdateProperties(self:data())
	end
end

function Daily:data()
	return {
		hangQC = self:getProperty("hangQC"),
		dinerQC = self:getProperty("dinerQC"),
	}
end

return Daily