local skynet = require "skynet"
require "skynet.manager"
local crab = require "crab.c"

local table_insert = table.insert
local table_unpack = table.unpack
local mode, id, dict = ...

local function toutf8(name)
	local t = {}
	for _, v in utf8.codes(name) do
		table_insert(t, v)
	end
	return t
end

if mode == "sub" then
	local CMD = {}
	dict = tonumber(dict)

	function CMD.check(name)
		if name:find("%c") then
			return false
		end
		local utftb = toutf8(name)
		if crab.filter(dict, utftb) then
			return false, utf8.char(table_unpack(utftb))
		end
		return true
	end

	skynet.start(function()
		skynet.dispatch("lua", function(_, _, command, ...)
			local f = CMD[command]
			skynet.ret(skynet.pack(f(...)))
		end)

		skynet.register(string.format("NAMED%d", id))
	end)
else
	skynet.start(function()
		local ok, forbidNames = pcall(require, "csvdata.name_forbid")
		if not ok then forbidNames = {} end

		local words = {}
		for _, data in ipairs(forbidNames) do
			local ok, utftb = pcall(toutf8, data.name)
			if ok then table.insert(words, utftb) end
		end
		local d = crab.open(words)

		for i = 1, 5 do
			skynet.newservice(SERVICE_NAME, "sub", i, d)
		end
	end)
end
