local skynet = require "skynet"
require "skynet.manager"
local redis = require "skynet.db.redis"

local db

local command = {}

function command.open(conf)
	db = redis.connect({
		host = conf.redishost,
		port = conf.redisport,
		db = conf.redisdb or 0,
		auth = conf.auth,
	})

	--[[
	local csvdata = require("csvdata.world_boss_battle")
	for i=1, #csvdata do
		for j=1, #csvdata[i] do
			db:del(string.format("boss:%d:%d", i, j))
		end
	end
	--]]
	db:del("rtpvp")

end

skynet.start(function()
	skynet.dispatch("lua", function(session, address, cmd, ...)
		if cmd == "open" then
			local f = command[string.lower(cmd)]
			skynet.ret(skynet.pack(f(...)))
		else
			skynet.ret(skynet.pack(db[string.lower(cmd)](db, ...)))
		end
	end)
	skynet.register "REDIS"
end)